Attribute VB_Name = "SetWindowSize"
Option Explicit

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type POINTAPI
        x As Long
        y As Long
End Type

Private Type MINMAXINFO
        ptReserved As POINTAPI
        ptMaxSize As POINTAPI
        ptMaxPosition As POINTAPI
        ptMinTrackSize As POINTAPI
        ptMaxTrackSize As POINTAPI
End Type

Private Const GWL_WNDPROC = (-4)

Private Const WM_DESTROY = &H2
Private Const WM_GETMINMAXINFO = &H24

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByRef lParam As MINMAXINFO) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Private m_colOldProcs           As Collection
Private m_colControls           As Collection

Private m_lngWidth              As Long
Private m_lngHight              As Long

Public Function SetMinSaizeForm(ByRef r_frmForm As Form, _
                        Optional ByVal v_lngWidthPoint As Long = -1, _
                        Optional ByVal v_lngHightPoint As Long = -1 _
                        ) As Boolean
    Dim udtRect         As RECT

    SetMinSaizeForm = False
    Call GetWindowRect(r_frmForm.hwnd, udtRect)
    If v_lngWidthPoint < 0 Then
        m_lngWidth = udtRect.Right - udtRect.Left
    Else
        m_lngWidth = v_lngWidthPoint
    End If
    If v_lngHightPoint < 0 Then
        m_lngHight = udtRect.Bottom - udtRect.Top
    Else
        m_lngHight = v_lngHightPoint
    End If
    If SubClassWindow(r_frmForm, AddressOf WindowProc) = False Then
        Exit Function
    End If
    SetMinSaizeForm = True
End Function

Private Function SubClassWindow(ByRef r_ctlControl As Object, ByVal v_lngAddress As Long) As Boolean
On Error GoTo ErrorHandler:
    Dim lngRet          As Long
    Dim lngProc         As Long

    SubClassWindow = False

    lngProc = GetWindowLong(r_ctlControl.hwnd, GWL_WNDPROC)
    lngRet = SetWindowLong(r_ctlControl.hwnd, GWL_WNDPROC, v_lngAddress)

    If m_colOldProcs Is Nothing Then
        Set m_colOldProcs = New Collection
        Set m_colControls = New Collection
    End If
    Call m_colOldProcs.Add(lngProc, CStr(r_ctlControl.hwnd))
    Call m_colControls.Add(r_ctlControl, CStr(r_ctlControl.hwnd))

    SubClassWindow = True
    Exit Function
ErrorHandler:
End Function

Private Function WindowProc( _
                ByVal lngWnd As Long, _
                ByVal lngMsg As Long, _
                ByVal lngWParam As Long, _
                ByRef lngLParam As MINMAXINFO _
                ) As Long
    Dim lngRet          As Long

    Select Case lngMsg
        Case WM_DESTROY
            lngRet = SetWindowLong(lngWnd, GWL_WNDPROC, m_colOldProcs(CStr(lngWnd)))
        Case WM_GETMINMAXINFO               'TCY̗}
            lngLParam.ptMinTrackSize.x = 707 'm_lngWidth
            lngLParam.ptMinTrackSize.y = 605 'm_lngHight
            WindowProc = 0
            Exit Function
    End Select

    lngRet = CallWindowProc(m_colOldProcs(CStr(lngWnd)), lngWnd, lngMsg, lngWParam, lngLParam)

    If lngMsg = WM_DESTROY Then
        m_colOldProcs.Remove (CStr(lngWnd))
        m_colControls.Remove (CStr(lngWnd))
        If m_colOldProcs.Count = 0 Then
            Set m_colOldProcs = Nothing
        End If
        If m_colControls.Count = 0 Then
            Set m_colControls = Nothing
        End If
    End If

    WindowProc = lngRet
End Function
